#include "DirectX.h"
#include "Window.h"

// DirectX9̐ÓICuN
#pragma comment(lib, "d3d9.lib")

IDirect3D9*		g_pD3D = NULL;
IDirect3DDevice9*	g_pDevice = NULL;

// DirectX̏
bool InitializeDirectX(HWND hWnd, int width, int height, bool isFullscreen)
{
	// IDirect3D9IuWFNg̍쐬
	if ((g_pD3D = Direct3DCreate9(D3D_SDK_VERSION)) == NULL)
	{
		return false;
	}

	D3DPRESENT_PARAMETERS d3dpp;
	ZeroMemory(&d3dpp, sizeof(D3DPRESENT_PARAMETERS));
	// Device̐ݒ
	d3dpp.Windowed = !isFullscreen;
	d3dpp.hDeviceWindow = hWnd;
	d3dpp.BackBufferWidth = width;
	d3dpp.BackBufferHeight = height;
	d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.MultiSampleType = D3DMULTISAMPLE_NONE;
	d3dpp.MultiSampleQuality = 0;
	d3dpp.Flags = 0;
	d3dpp.BackBufferCount = 1;
	d3dpp.EnableAutoDepthStencil = true;
	d3dpp.AutoDepthStencilFormat = D3DFMT_D24S8;
	// VSYNC҂L)
	d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_ONE;
	d3dpp.FullScreen_RefreshRateInHz = D3DPRESENT_RATE_DEFAULT;

	// Direct3DfoCX̐
	if (FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT,
		D3DDEVTYPE_HAL,
		d3dpp.hDeviceWindow,
		D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED,
		&d3dpp,
		&g_pDevice)))
	{
		SAFE_RELEASE(g_pD3D);
		return false;
	}
	return true;
}

// DirectX̏I
void FinalizeDirectX(void)
{
	SAFE_RELEASE(g_pDevice);
	SAFE_RELEASE(g_pD3D);
}

// Direct3DIuWFNg̎擾
IDirect3D9* GetDirect3D(void) { return g_pD3D; }
// Direct3DDeviceIuWFNg̎擾
IDirect3DDevice9* GetDirect3DDevice(void) { return g_pDevice; }