#include "stdafx.h"
#include "Drawing.h"
#include "DirectX.h"
#include "Player.h"
#include "Enemy.h"
#include "PlayerBullet.h"
#include "EnemyBullet.h"
#include "UI.h"
#include "global.h"
#include "Game_Title.h"
#include "Game_Over.h"
#include "Enemy_MoveMent.h"

#define FVF_CUSTOM2D    (D3DFVF_XYZRHW | D3DFVF_DIFFUSE)
#define FVF_CUSTOM2D1    (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)

struct SimpleVertex
{
	float x, y, z;
	float rhw;
	DWORD color;
};

struct SimpleVertex1
{
	float x, y, z;
	float rhw;
	DWORD color;
	float u, v;
};

//lp`
void BlockRender(float x1, float y1, float x2, float y2)
{
	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	const SimpleVertex vertices[4] =
	{
		{ x1, y1, 0.0f, 1.0f, 0xffffffff },
		{ x2, y1, 0.0f, 1.0f, 0xffffffff },
		{ x1, y2, 0.0f, 1.0f, 0xffffffff },
		{ x2, y2, 0.0f, 1.0f, 0xffffffff },
	};
	// _tH[}bg̎w
	pDevice->SetFVF(FVF_CUSTOM2D);
	// `
	pDevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, vertices, sizeof(SimpleVertex));
}

//摜`
// _obt@̐
IDirect3DVertexBuffer9* CreateVertexBuffer(const void* pVertices, size_t size)
{
	IDirect3DVertexBuffer9* pVertexBuffer;
	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	// w肵TCY̒_obt@쐬
	if (FAILED(pDevice->CreateVertexBuffer(size, 0, 0, D3DPOOL_MANAGED, &pVertexBuffer, NULL)))
	{
		return NULL;
	}
	void* pData;
	// obt@bNăf[^
	if (SUCCEEDED(pVertexBuffer->Lock(0, size, &pData, 0)))
	{
		memcpy(pData, pVertices, size);
		pVertexBuffer->Unlock();
	}
	return pVertexBuffer;
}
// eNX`[̓ǂݍ
bool LoadTexture(const WCHAR* pFileName, TextureData* pOut)
{
	if (pOut == NULL) return false;
	IDirect3DTexture9* pTexture;
	D3DXIMAGE_INFO info;
	// t@CeNX`[𐶐
	HRESULT hr = D3DXCreateTextureFromFileEx(
		GetDirect3DDevice(),	// Direct3DDevice
		pFileName,		// t@C
		D3DX_DEFAULT,		// (D3DX_DEFAULTŃt@C画)
		D3DX_DEFAULT,		// (D3DX_DEFAULTŃt@C画)
		1,			// ~bv}bv̐
		0,			// gppr
		D3DFMT_A8R8G8B8,	// tH[}bg
		D3DPOOL_MANAGED,	// ̊Ǘݒ
		D3DX_FILTER_NONE,	// tB^[ݒ
		D3DX_DEFAULT,		// ~bv}bvtB^[̐ݒ
		0x00000000,		// J[L[
		&info,			// 摜
		NULL,			// pbgf[^
		&pTexture);		// eNX`[̊i[
	if (FAILED(hr))
	{
		return false;
	}
	D3DSURFACE_DESC desc;
	// eNX`[̏擾
	pTexture->GetLevelDesc(0, &desc);
	// eNX`[̐ݒ
	pOut->pTexture = pTexture;
	pOut->srcWidth = info.Width;
	pOut->srcHeight = info.Height;
	pOut->width = desc.Width;
	pOut->height = desc.Height;

	return true;
}
void ReleaseTexture(TextureData* pTextureData)
{
	if (pTextureData == NULL) return;

	SAFE_RELEASE(pTextureData->pTexture);
}
IDirect3DVertexBuffer9* g_pVertexBuffer;
//	\[X̏
bool InitializeResource(float x0, float y0, float x1, float y1, float x2, float y2, float x3, float y3, TextureData g_texData)
{
	// 摜TCY畝ƍݒ
	// eNX`[TCY摜TCYUV擾(摜2̗ݏł1.0fɂȂ)
	float u = (float)g_texData.srcWidth / (float)g_texData.width;
	float v = (float)g_texData.srcHeight / (float)g_texData.height;
	// 摜TCYɍ킹UVǉ_f[^
	const SimpleVertex1 vertices[4] =
	{
		// 1ڂ̋`
		{ x0, y0, 0.0f, 1.0f, 0xffffffff, 0.0f, 0.0f },
		{ x1, y1, 0.0f, 1.0f, 0xffffffff,    u, 0.0f },
		{ x2, y2, 0.0f, 1.0f, 0xffffffff, 0.0f,    v },
		{ x3, y3, 0.0f, 1.0f, 0xffffffff,    u,    v },
	};
	// _obt@̐
	g_pVertexBuffer = CreateVertexBuffer(vertices, sizeof(vertices));
	if (g_pVertexBuffer == NULL)
	{
		return false;
	}
	return true;
}
bool InitializeResource(float x1, float y1, float x2, float y2, TextureData g_texData)
{
	return InitializeResource(x1, y1, x2, y1, x1, y2, x2, y2, g_texData);
}
void CleanupResource(TextureData g_texData)
{
	ReleaseTexture(&g_texData);
}
void SetDefaultRenderState()
{
	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	// JO[h
	pDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// tB[h
	pDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
	// Zobt@Lɂ邩H
	pDevice->SetRenderState(D3DRS_ZENABLE, true);
	// Zobt@݂̏Lɂ邩H
	pDevice->SetRenderState(D3DRS_ZWRITEENABLE, true);
	// Zobt@݂̏Lɂ邩H
	pDevice->SetRenderState(D3DRS_ZFUNC, D3DPCMPCAPS_ALWAYS);
	// uhLɂ邩H
	pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, true);
	// eXgLɂ邩H
	pDevice->SetRenderState(D3DRS_ALPHATESTENABLE, true);
	// eXg̔@
	pDevice->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_NOTEQUAL);
	// eXg̎Qƒl
	pDevice->SetRenderState(D3DRS_ALPHAREF, 0);

	// `ݒ
	pDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	pDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

	// J[Xe[Wݒ
	pDevice->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
	pDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	pDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_CURRENT);
	// Xe[Wݒ
	pDevice->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);
	pDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);
	pDevice->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_CURRENT);
	// eNX`[tB^[̐ݒ
	pDevice->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_NONE);
	pDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	pDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	// eNX`[̃AhbVO[h̐ݒ
	pDevice->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP);
	pDevice->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP);
}

// `惂[h
enum ERenderMode
{
	Normal,		// 
	Add,		// Z
	Subtract,	// Z
	Multiple,	// Z
};
void release() {
	SAFE_RELEASE(g_pVertexBuffer);
}
// `Xe[g̐ݒ
void SetRenderMode(ERenderMode mode, bool enableAlpha)
{
	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	// ȏꍇ͓͂ꂽJ[̂܂܎g
	DWORD srcColorblend = D3DBLEND_ONE;
	DWORD dstColorblend = D3DBLEND_ZERO;
	if (enableAlpha)
	{
		// Lȏꍇ̓lJ[ɉe
		srcColorblend = D3DBLEND_SRCALPHA;
		dstColorblend = D3DBLEND_INVSRCALPHA;
		// eXgŃl0̏ꍇ͕`Ȃ悤ɐݒ
		pDevice->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_NOTEQUAL);
		pDevice->SetRenderState(D3DRS_ALPHAREF, 0);
	}
	// uhƃeXg̗Lݒ
	pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, enableAlpha);
	pDevice->SetRenderState(D3DRS_ALPHATESTENABLE, enableAlpha);

	switch (mode)
	{
	case Normal:
		// F(SrcColor * 1) + (DestColor * 0)
		// LF(SrcColor * ) + (DestColor * (1 - ))
		pDevice->SetRenderState(D3DRS_BLENDOP, D3DBLENDOP_ADD);
		pDevice->SetRenderState(D3DRS_SRCBLEND, srcColorblend);
		pDevice->SetRenderState(D3DRS_DESTBLEND, dstColorblend);
		break;
	case Add:
		// F(SrcColor * 1) + (DestColor * 1)
		// LF(SrcColor * ) + (DestColor * 1)
		pDevice->SetRenderState(D3DRS_BLENDOP, D3DBLENDOP_ADD);
		pDevice->SetRenderState(D3DRS_SRCBLEND, srcColorblend);
		pDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
		break;
	case Subtract:
		// F(DestColor * 1) - (SrcColor * 1)
		// LF(DestColor * 1) - (SrcColor * )
		pDevice->SetRenderState(D3DRS_BLENDOP, D3DBLENDOP_REVSUBTRACT);
		pDevice->SetRenderState(D3DRS_SRCBLEND, srcColorblend);
		pDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
		break;
	case Multiple:
		// ʁF(SrcColor * 0) + (DestColor * SrcColor)
		pDevice->SetRenderState(D3DRS_BLENDOP, D3DBLENDOP_ADD);
		pDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ZERO);
		pDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_SRCCOLOR);
		break;
	}
}

void Render()
{
	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	// `V[̊Jn
	pDevice->BeginScene();
	// obNobt@̃NA
	pDevice->Clear(0, NULL, D3DCLEAR_TARGET, 0x00000000, 1.0f, 0);
	// ftHg̕`Xe[gݒ
	SetDefaultRenderState();
	// ʏ폑݃[hɐݒ
	SetRenderMode(Normal, true);
	//BlockRender(60, 60, 400, 400);			//̊ԂɂubN`ł悤ɂȂĂ

	//`֌W
	if (Game_State == GAME_TITLE) {
		Title_Render();
	}
	if (Game_State == GAME_MAIN) {
		Enemy_MoveMent_Render();
		Enemy_Render();
		Player_Bullet_Render();
		Player_Render();
		Enemy_Bullet_Render();
		UI_Render();
	}
	if (Game_State == GAME_END) {
		Game_Over_Render();
	}

	// `V[̏I
	pDevice->EndScene();

	// j^[ɊG\
	pDevice->Present(NULL, NULL, NULL, NULL);
}


void DrowTexture(float x1, float y1, float x2, float y2, TextureData g_texData) {

	release();

	InitializeResource(x1, y1, x2, y2, g_texData);

	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	// eNX`[̐ݒ
	pDevice->SetTexture(0, g_texData.pTexture);
	// _obt@̐ݒ
	pDevice->SetStreamSource(0, g_pVertexBuffer, 0, sizeof(SimpleVertex1));
	// _tH[}bg̎w
	pDevice->SetFVF(FVF_CUSTOM2D1);
	// `
	pDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
}
void DrowTexture(float x0, float y0, float x1, float y1, float x2, float y2, float x3, float y3, TextureData g_texData) {

	release();

	InitializeResource(x0, y0, x1, y1, x2, y2, x3, y3, g_texData);

	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	// eNX`[̐ݒ
	pDevice->SetTexture(0, g_texData.pTexture);
	// _obt@̐ݒ
	pDevice->SetStreamSource(0, g_pVertexBuffer, 0, sizeof(SimpleVertex1));
	// _tH[}bg̎w
	pDevice->SetFVF(FVF_CUSTOM2D1);
	// `
	pDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
}