#include "GameState.h"
#include "Player.h"
#include "Enemy.h"
#include "Drawing.h"
#include "PlayerBullet.h"
#include "EnemyBullet.h"
#include "UI.h"
#include "global.h"
#include "Game_Title.h"
#include "Game_Over.h"
#include "Enemy_MoveMent.h"
#include "Key_Check.h"

int Game_State;
int key_on;			//keyĂ邩
int key_old;		//1t[Okey
int key_up;			//ꂽ1t[̂ݔ
int key_push;		//L[Ƃ

void Game_Initialize_Texture() {
	Enemy_MoveMent_Initialize_Texture();
	Enemy_Initialize_Texture();
	Enemy_Bullet_Initialize_Texture();
	Game_Over_Initialize_Texture();
	Title_Initialize_Texture();
	Playr_Initialize_Texture();
	Playr_Bullet_Initialize_Texture();
	UI_Initialize_Texture();
}

void Game_Initialize() {
	Enemy_MoveMent_Initialize();
	Player_Bullet_Initialize();
	Player_Initialize();
	Enemy_Bullet_Initialize();
	Enemy_Initialize();
	UI_Initialize();
	Title_Initialize();
	Game_Over_Initialize();
	Game_State = GAME_TITLE;
}

void Game_Update() {
	key_old = key_on;
	key_on = CheckKey();
	key_push = (key_on ^ key_old) & key_on;
	key_up = (key_on ^ key_old) & key_old;
	if (Game_State == GAME_TITLE) {
		Title_Update();
	}
	if (Game_State == GAME_MAIN) {
		Player_Bullet_Update();
		Player_Update();
		Enemy_Update();
		UI_Update();
		Enemy_Bullet_Update();
	}
	if (Game_State == GAME_END) {
		Game_Over_Update();
	}
	if (Game_State == GAME_LOAD) {
		Game_Initialize();
	}
}

void Game_Render() {
	if (Game_State != GAME_LOAD) {
		Render();
	}
}

void Game_Open() {
	Player_Bullet_Open();
	Enemy_Bullet_Open();
	Enemy_MoveMent_Open();
	Player_Open();
	Enemy_Open();
	UI_Open();
	Title_Open();
	Game_Over_Open();
}