#include "Hit_Judgment.h"
#include "global.h"
#include "DirectX.h"
#include <d3dx9.h>

//ʃTCY
#define MAINSCREEN_X1 10			//CXN[x̍Œl
#define MAINSCREEN_X2 570			//CXN[x̍ōl
#define MAINSCREEN_Y1 10			//CXN[y̍Œl
#define MAINSCREEN_Y2 710			//CXN[y̍ōl

bool Out_Of_Screen_Judgment_Bullet(float x, float y) {
	if (MAINSCREEN_X1 <= x && MAINSCREEN_X2 >= x && MAINSCREEN_Y1 <= y && MAINSCREEN_Y2 >= y) return true;
	return false;
}

bool Out_Of_Screen_Judgment_Bullet_hansya_X(float x, float y) {
	if (MAINSCREEN_X1 >= x || MAINSCREEN_X2 <= x) return true;
	return false;
}
bool Out_Of_Screen_Judgment_Bullet_hansya_Y(float x, float y) {
	if (MAINSCREEN_Y1 >= y) return true;
	return false;
}
bool Out_Of_Screen_Judgment_Bullet_hansya_Y2(float x, float y) {
	if (MAINSCREEN_Y2 <= y)  return true;
	return false;
}

int Out_Of_Screen_Judgment_X(float x) {
	if (MAINSCREEN_X1 > x) {
		return MAINSCREEN_X1;
	}
	if (MAINSCREEN_X2 < x) {
		return MAINSCREEN_X2;
	}
	return false;
}

int Out_Of_Screen_Judgment_Y(float y) {
	if (MAINSCREEN_Y1 > y) {
		return MAINSCREEN_Y1;
	}
	if (MAINSCREEN_Y2 < y) {
		return MAINSCREEN_Y2;
	}
	return false;
}



//WNX
class Point {
public:
	float x, y;//W

	Point() { x = y = 0; }
	template<typename T, typename U>
	Point(T x, U y) { this->x = (float)x; this->y = (float)y; }
};

//ړ̃NX
class Mover : public Point {
public:
	float r;//蔼a
	Mover() { r = 0; }
};

//[U[NX
class Lazer {
public:
	Point p[4];
};


//typedef錾
typedef Point Vector;

//xNg֐
Vector CreateVector(const Point &p, const Point &q) {
	return Vector(q.x - p.x, q.y - p.y);//p->qxNg
}

//xNg̓
float InnerProduct(const Vector &a, const Vector &b) {
	return (a.x*b.x + a.y*b.y);//aEb
}

//xNg̊O
float OuterProduct(const Vector &a, const Vector &b) {
	return (a.x*b.y - a.y*b.x);//a~b
}

//xNg̒2
float VectorLength2(const Vector &v) {
	return InnerProduct(v, v);//vEv=|v|^2
}

//~Ɖ~̐ڐG
bool MoverCollision(const Mover &m1, const Mover &m2) {
	float dx, dy, r;
	dx = m2.x - m1.x;
	dy = m2.y - m1.y;
	r = m2.r + m1.r;
	return ((dx*dx) + (dy*dy) < (r*r));//Ătrue
}

//[U[̒[_Ƃ̐ڐG
bool LazerCollision1(const Lazer &laz, const Mover &m) {
	Mover t;

	for (int i = 0; i < 4; i++) {
		t.x = laz.p[i].x;	t.y = laz.p[i].y;
		if (MoverCollision(t, m)) {
			return true;
		}
	}

	return false;
}

//[Ůe()Ɖ~̐ڐG
bool LazerCollision2(const Lazer &laz, const Mover &m) {
	Vector pq, pm;
	float inner, k, pqd2, pmd2, phd2, d2;

	const int n[][4] = { {0,1,3,2},{1,3,2,0} };
	for (int i = 0; i < 4; i++) {
		pq = CreateVector(laz.p[n[0][i]], laz.p[n[1][i]]);//0.1.3.2:1.3.2.0
		pm = CreateVector(laz.p[n[0][i]], (Point)m);

		inner = InnerProduct(pq, pm);
		pqd2 = VectorLength2(pq);
		pmd2 = VectorLength2(pm);

		k = inner / pqd2;
		if (k < 0 || 1 < k)continue;
		phd2 = inner * k;

		d2 = pmd2 - phd2;

		if (d2 < m.r*m.r)return true;
	}

	return false;
}

//[U[ɓ荞łȂ̔
bool LazerCollision3(const Lazer &laz, const Mover &m) {
	Vector pp, pm;
	float inner, outer, theta[2];

	for (int i = 0; i < 2; i++) {
		pp = CreateVector(laz.p[i * 3], laz.p[1 + i]);//0.1:3.2
		pm = CreateVector(laz.p[i * 3], (Point)m);

		inner = InnerProduct(pp, pm);
		outer = OuterProduct(pp, pm);

		theta[i] = (atan2(outer, inner)*(180 / PI));
	}

	if (0 <= theta[0] && theta[0] <= 90 &&
		0 <= theta[1] && theta[1] <= 90) {
		return true;
	}

	return false;
}

//[U[(`)Ɖ~̐ڐG
bool LazerCollision(const Lazer &laz, const Mover &m) {
	bool(*lazer_collision[])(const Lazer &laz, const Mover &m) = {
		LazerCollision1,
		LazerCollision2,
		LazerCollision3,
	};

	for (int i = 0; i < 3; i++) {
		if ((*lazer_collision[i])(laz, m)) {
			return true;
		}
	}
	return false;
}