#include "PlayerBullet.h"
#include "DirectX.h"
#include "Drawing.h"
#include <d3dx9.h>
#include "Enemy.h"
#include "global.h"
#include "Hit_Judgment.h"

//eNX`f[^[
TextureData Bullet;  //e

	int count_A = 0;
	int count_B = 0;
	int count_C = 0;

struct BULLET {
	int isLive;
	float x, y;
	float vx, vy;
	float dir;
	float angle;
	float speed;
};
BULLET bullet[BULLET_MAX];

void Playr_Bullet_Initialize_Texture() {
	LoadTexture(TEXT("assets/D_bullet_A.png"), &Bullet);//摜ǂݍŃeNX`֐ɓ
}

void Player_Bullet_Initialize()
{
	count_A = 0;
	count_B = 0;
	count_C = 0;
	for (int i = 0; i < BULLET_MAX; i++) {
		bullet[i].isLive = false;
		bullet[i].x = 0;
		bullet[i].y = 0;
		bullet[i].vx = 0;
		bullet[i].vy = 0;
		bullet[i].dir = 0;
		bullet[i].angle = 0;
		bullet[i].speed = 0;
	}
}

	//e̔ˏ
void Player_Bullet_call_A(float x, float y) {
	count_A++;
	if (count_A == 2) {
		int i = 0;
		for (; i < BULLET_MAX; i++) {
			if (!bullet[i].isLive) {
				break;
			}
		}
		if (i == BULLET_MAX) {
			return;
		}
		bullet[i].isLive = true;
		bullet[i].x = x;
		bullet[i].y = y;
		if (key_on&KEYIN_SFT) {
			bullet[i].angle = 4.8f;
		} else {
			bullet[i].angle = 4.9f;
		}
		bullet[i].speed = 20.0f;
		count_A = 0;
	}
}
void Player_Bullet_call_B(float x, float y) {
	count_B++;
	if (count_B == 2) {
		int i = 0;
		for (; i < BULLET_MAX; i++) {
			if (!bullet[i].isLive) {
				break;
			}
		}
		if (i == BULLET_MAX) {
			return;
		}
		bullet[i].isLive = true;
		bullet[i].x = x;
		bullet[i].y = y;
		bullet[i].angle = 4.7f;
		bullet[i].speed = 20.0f;
		count_B = 0;
	}
}
void Player_Bullet_call_C(float x, float y) {
	count_C++;
	if (count_C == 2) {
		int i = 0;
		for (; i < BULLET_MAX; i++) {
			if (!bullet[i].isLive) {
				break;
			}
		}
		if (i == BULLET_MAX) {
			return;
		}
		bullet[i].isLive = true;
		bullet[i].x = x;
		bullet[i].y = y;
		if (key_on&KEYIN_SFT) {
			bullet[i].angle = 4.6f;
		} else {
			bullet[i].angle = 4.5f;
		}
		bullet[i].speed = 20.0f;
		count_C = 0;
	}
}
//ěĂяo
void Player_Bullet_Call(float x1, float y1, float x2, float y2, float x3, float y3) {
	Player_Bullet_call_A(x1,y1);
	Player_Bullet_call_B(x1,y1);
	Player_Bullet_call_C(x1,y1);
	Player_Bullet_call_A(x2, y2);
	Player_Bullet_call_B(x2, y2);
	Player_Bullet_call_C(x2, y2);
	Player_Bullet_call_A(x3, y3);
	Player_Bullet_call_B(x3, y3);
	Player_Bullet_call_C(x3, y3);
}

void Player_Bullet_Update()
{
	//WXV
	for (int i = 0; i < BULLET_MAX; i++) {
		if (!bullet[i].isLive) {
			continue;
		}
		bullet[i].x += cos(bullet[i].angle) *bullet[i].speed;      // xWXV
		bullet[i].y += sin(bullet[i].angle) * bullet[i].speed;      // yWXV
		//ʊOɒes
		bool screenfrag = Out_Of_Screen_Judgment_Bullet(bullet[i].x,bullet[i].y);
		bullet[i].isLive = screenfrag;
		//vC[ɓ
		bool Hitfrag = Enemy_Hit_Decision(bullet[i].x, bullet[i].y);
		if (Hitfrag == true) {
			bullet[i].isLive = false;
		}
	}
}

void Player_Bullet_Render()
{
	for (int i = 0; i < BULLET_MAX; i++) {
		if (!bullet[i].isLive) {
			continue;
		}
		DrowTexture(
			bullet[i].x - BULLET_TEXTURE_SIZE,//x1
			bullet[i].y - BULLET_TEXTURE_SIZE,//y1
			bullet[i].x + BULLET_TEXTURE_SIZE,//x2
			bullet[i].y + BULLET_TEXTURE_SIZE,//y2
			Bullet);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
	}
}

void Player_Bullet_Open()
{
	CleanupResource(Bullet);
}
