#include "VertexIndex.h"
#include "stdafx.h"
#include "fbxsdk.h"

void DisplayContent(FbxScene* pScene);
void DisplayContent(FbxNode* pNode);
void DisplayMesh(FbxNode* pNode);
void DisplayIndex(FbxMesh* mesh);
void DisplayPosition(FbxMesh* mesh);


int Vertex() {
	//FbxManagerFbxSceneIuWFNg쐬
	FbxManager* manager = FbxManager::Create();
	FbxIOSettings* ios = FbxIOSettings::Create(manager, IOSROOT);
	manager->SetIOSettings(ios);
	FbxScene* scene = FbxScene::Create(manager, "");

	//f[^C|[g
	const char* filename = "ao_twinte_chan.fbx";
	std::cout << "File: " << filename << std::endl;
	FbxImporter* importer = FbxImporter::Create(manager, "");
	importer->Initialize(filename, -1, manager->GetIOSettings());
	importer->Import(scene);
	importer->Destroy();

	//Op|S
	FbxGeometryConverter geometryConverter(manager);
	geometryConverter.Triangulate(scene, true);

	DisplayContent(scene);



	manager->Destroy();
	return 0;
}
void DisplayContent(FbxScene* scene)
{
	FbxNode* node = scene->GetRootNode();

	if (node)
	{
		for (int i = 0; i < node->GetChildCount(); i++)
		{
			DisplayContent(node->GetChild(i));
		}
	}
}

void DisplayContent(FbxNode* node)
{
	FbxNodeAttribute::EType lAttributeType;

	if (node->GetNodeAttribute() == NULL)
	{
		std::cout << "NULL Node Attribute\n\n";
	}
	else
	{
		lAttributeType = (node->GetNodeAttribute()->GetAttributeType());

		switch (lAttributeType)
		{
		default:
			break;

		case FbxNodeAttribute::eMesh:
			DisplayMesh(node);
			break;
		}
	}


	for (int i = 0; i < node->GetChildCount(); i++)
	{
		DisplayContent(node->GetChild(i));
	}
}

void DisplayMesh(FbxNode* node)
{
	FbxMesh* mesh = (FbxMesh*)node->GetNodeAttribute();

	std::cout << "\n\nMesh Name: " << (char *)node->GetName() << std::endl;

	DisplayIndex(mesh);
	DisplayPosition(mesh);

}

void DisplayIndex(FbxMesh* mesh)
{
	//|S
	int polygonNum = mesh->GetPolygonCount();

	//pڂ̃|Sւ̏
	for (int p = 0; p < polygonNum; ++p)
	{
		//pڂ̃|Snڂ̒_ւ̏
		for (int n = 0; n < 3; ++n)
		{
			int index = mesh->GetPolygonVertex(p, n);
			std::cout << "index[" << p + n << "] : " << index << std::endl;
		}
	}
}

void DisplayPosition(FbxMesh* mesh)
{
	int positionNum = mesh->GetControlPointsCount();	// _
	FbxVector4* position = mesh->GetControlPoints();	// _Wz

	for (int i = 0; i < positionNum; ++i)
	{
		std::cout << "position[" << i << "] : ("
			<< position[i][0] << ","
			<< position[i][1] << ","
			<< position[i][2] << ","
			<< position[i][3] << ")" << std::endl;
	}
}